'                                  FUNZIONI.BAS
'
'                              libreria di funzioni
'
'  versione 2.1                                                   rev. 06.90
'

' ------------------------------------------------------------------------------
'          IMPORTANTE: ricordarsi sempre di dichiarare le FUNCTION
'                      nel programma che le utilizza
' ------------------------------------------------------------------------------

DECLARE FUNCTION LCAR$ (V$, L!)
DECLARE FUNCTION LNUM$ (V!, L!)
DECLARE FUNCTION MAX! (A!, B!)
DECLARE FUNCTION MIN! (A!, B!)
DECLARE FUNCTION NUM$ (V!)
DECLARE FUNCTION RNUM$ (V!, L!)

' ================================ LCAR$ =======================================
'
'  Funzione che fornisce una stringa di L caratteri contenente
'  la stringa V$, allineata a sinistra
'
'  Variabili di ingresso:
'     V$        stringa di partenza
'     L         lunghezza della stringa da generare
'
'  Annotazioni:
'     se la stringa di partenza e` troppo lunga la tronca,
'        senza effettuare nessuna segnalazione
'     se L non e` un numero intero, viene troncato all'unita`
'
' ------------------------------------------------------------------------------
FUNCTION LCAR$ (V$, L)

    L0 = INT(L)
    Lung = LEN(V$)
    SELECT CASE Lung
       CASE IS > L0
          LCAR$ = LEFT$(V$, L0)
       CASE L0
          LCAR$ = V$
       CASE IS < L0
          LCAR$ = V$ + SPACE$(L0 - Lung)
    END SELECT

END FUNCTION

' ================================ LNUM$ =======================================
'  
'  Funzione che fornisce una stringa di L caratteri corrispondente
'  al numero V, allineato a sinistra
'
'  Variabili di ingresso:
'     V         numero da trasformare in stringa
'     L         lunghezza della stringa da generare
'
'  Annotazioni:
'     se il numero e` troppo lungo lo tronca se cos facendo non si perdono
'        cifre intere, oppure riempe la stringa di asterischi
'     se L non e` un numero intero, viene troncato all'unita`
'
' ------------------------------------------------------------------------------
FUNCTION LNUM$ (V, L)

    L0 = INT(L)
    V$ = LTRIM$(STR$(V))
    Lung = LEN(V$)
    SELECT CASE Lung
       CASE IS > L0
          P = INSTR(V$, ".")
          IF P = 0 OR P > L0 + 1 THEN
             LNUM$ = STRING$(L0, "*")
          ELSE
             LNUM$ = LEFT$(V$, L0)
          END IF
       CASE L0
          LNUM$ = V$
       CASE IS < L0
          LNUM$ = V$ + SPACE$(L0 - Lung)
    END SELECT

END FUNCTION

' ================================ MAX =========================================
'
'  Funzione che fornisce il maggiore tra i due valori A e B
'
'  Variabili di ingresso:
'     A, B      valori da confrontare
'
' ------------------------------------------------------------------------------
FUNCTION MAX (A, B)

    IF A > B THEN MAX = A ELSE MAX = B

END FUNCTION

' ================================ MIN =========================================
'
'  Funzione che fornisce il minore tra i due valori A e B
'
'  Variabili di ingresso:
'     A, B      valori da confrontare
'
' ------------------------------------------------------------------------------
FUNCTION MIN (A, B)

    IF A < B THEN MIN = A ELSE MIN = B

END FUNCTION

' ================================ NUM$ ========================================
'
'  Funzione che fornisce una stringa corrispondente al numero V,
'  senza spazi bianchi iniziali
'
'  Variabili di ingresso:
'     V         numero da trasformare in stringa
'
' ------------------------------------------------------------------------------
FUNCTION NUM$ (V)

    NUM$ = LTRIM$(STR$(V))

END FUNCTION

' ================================ RNUM$ =======================================
'
'  Funzione che fornisce una stringa di L caratteri corrispondente
'  al numero V, allineato a destra
'
'  Variabili di ingresso:
'     V         numero da trasformare in stringa
'     L         lunghezza della stringa da generare
'
'  Annotazioni:
'     se il numero e` troppo lungo lo tronca se cos facendo non si perdono
'        cifre intere, oppure riempe la stringa di asterischi
'     se L non e` un numero intero, viene troncato all'unita`
'
' ------------------------------------------------------------------------------
FUNCTION RNUM$ (V, L)
  
    L0 = INT(L)
    V$ = LTRIM$(STR$(V))
    Lung = LEN(V$)
    SELECT CASE Lung
       CASE IS > L0
          P = INSTR(V$, ".")
          IF P = 0 OR P > L0 + 1 THEN
             RNUM$ = STRING$(L0, "*")
          ELSE
             RNUM$ = LEFT$(V$, L0)
          END IF
       CASE L0
          RNUM$ = V$
      CASE IS < L0
          RNUM$ = SPACE$(L0 - Lung) + V$
    END SELECT

END FUNCTION

