'                                  TRAVEFON
'
'                 Trave di fondazione su suolo alla Winkler
'
'  versione 2.0                                                 rev. 10.90
'
'  realizzato da:     Cattedra di Complementi di Tecnica delle Costruzioni
'                     gruppo di studio - anni accademici 1987/88 e 1989/90
'

' funzioni dal file FUNZIONI.BAS
DECLARE FUNCTION LCAR$ (V$, L!)
DECLARE FUNCTION LNUM$ (V!, L!)
DECLARE FUNCTION MAX! (A!, B!)
DECLARE FUNCTION MIN! (A!, B!)
DECLARE FUNCTION NUM$ (V!)
DECLARE FUNCTION RNUM$ (V!, L!)

' procedure dal file GRAFICA.BAS
DECLARE SUB ModGraf (Scheda!)

' procedure dal file MASKT.BAS
DECLARE SUB Aspetta (Sec!)
DECLARE SUB CampoT (Tipo!, UZ!, UF!(), UR!, UC!, UL!, UP$, UD$, UF!)
DECLARE SUB ErrBeep ()
DECLARE SUB PaginaTf (Cod!(), Descr$(), Utst!(), JZ!, UR!(), UC!(), UL!(), UD$(), UU!, SWC!)
DECLARE SUB PaginaTf2 (MOV!, Cod!(), Descr$(), Utst!(), RZ!, CZ!, UR!(), UC!(), UL!(), UD$(), UU!, SWC!)

' procedure di questo file
DECLARE SUB Ascisse (IZ!, B!, C!, E!, IN!, LC!(), X!(), LT!, LM!, LK!)
DECLARE SUB CalcolaRisultati (IZ!, B!, C!, LM!, LT!, LC!(), X!(), Q!, F!(), M!(), X1!, X2!, X3!, X4!, KX!(), W!(), FI!(), T!(), MF!(), ST!())
DECLARE SUB CoeffABCD (LM!, X!, AL!, BL!, CL!, DL!)
DECLARE SUB DefinisceIO (FI$, FO$)
DECLARE SUB Diagrammi (SCR!, IZ!, LT!, KX!(), X!(), MF!(), T!(), W!())
DECLARE SUB ForzeCorrettive (IZ!, LT!, LM!, B!, C!, F!(), M!(), X!(), X1!, X2!, X3!, X4!)
DECLARE SUB Inerzia ()
DECLARE SUB InputDati (MIS!, FO$)
DECLARE SUB LetturaDati (F!, MIS!, B!, IN!, EL!, E!, IZ!, NP!(), LC!(), CS!, C!, Q!, F!(), M!())
DECLARE SUB MemorizzazioneDati (F!, B!, IN!, EL!, IZ!, NP!(), LC!(), CS!, Q!, F!(), M!())
DECLARE SUB Menu (SCR!, Op%)
DECLARE SUB Pagina1 (Cod!(), Descr$(), I$, FI$, FO$, UU!)
DECLARE SUB Pagina2 (Cod!(), Descr$(), MIS!, B!, IN!, EL!, CS!, IZ!, UU!)
DECLARE SUB Pagina3 (Cod!(), Descr$(), IZ!, NP!(), UU!)
DECLARE SUB Pagina4 (Cod!(), Descr$(), IZ!, NP!(), LC!(), UU!)
DECLARE SUB Pagina5 (Cod!(), Descr$(), MIS!, IZ!, NP!(), Q!, F!(), M!(), UU!)
DECLARE SUB StampaDati (F!, MIS!, B!, IN!, EL!, IZ!, NP!(), LC!(), CS!, LM!, LK!, Q!, F!(), M!())
DECLARE SUB StampaRisultati (F!, MIS!, IZ!, NP!(), KX!(), MF!(), T!(), ST!(), W!(), FI!())
DECLARE SUB TraveInf (LM!, B!, C!, X!, S!, P!, M!, WX!, FX!, MX!, TX!)
DECLARE SUB TraveSeminf (LM!, B!, C!, X!, S!, P!, M!, WX!, FX!, MX!, TX!)
DECLARE SUB ValEstremi (IZ!, A!(), Amin!, Amax!)
DECLARE SUB Winkler (MIS!, SCR!, FI$)

CONST DC = 5, DS = 2, MI = 15

IF INSTR(COMMAND$, "/T") = 0 THEN MIS = 2 ELSE MIS = 1
' MIS=1   sistema tecnico
' MIS=2   sistema internazionale

CALL ModGraf(SCR)
DO
   CALL Menu(SCR, Op%)
   SELECT CASE Op%
      CASE 1
         CALL Inerzia
      CASE 2
         CALL InputDati(MIS, F$)
      CASE 3
         CALL Winkler(MIS, SCR, F$)
      CASE 4
         LOCATE 12, 32: PRINT "FINE  ELABORAZIONE"
   END SELECT
LOOP UNTIL Op% = 4

' ================================ Ascisse =====================================
'
'   Calcola le ascisse dei pilastri, la lunghezza totale della trave,
'   lambda e la lunghezza caratteristica
'
'   Variabili di ingresso:
'      IZ        numero di pilastri
'      B         larghezza della sottofondazione
'      C         costante elastica di sottofondo
'      E         modulo elastico del materiale
'      IN        momento di inerzia della sezione
'      LC()      luce delle campate;
'                   la luce dello sbalzo sinistro e` in LC(0)
'                   la luce dello sbalzo destro e` in LC(IZ)
'
'   Variabili di uscita:
'      X()       ascisse dei pilastri
'      LT        lunghezza totale della trave
'      LM        parametro caratteristico lambda
'      LK        lunghezza caratteristica
'
'   Variabili interne:
'      I         indice che individua il generico pilastro o campata
'
' ------------------------------------------------------------------------------
SUB Ascisse (IZ, B, C, E, IN, LC(), X(), LT, LM, LK)

    X(0) = 0
    FOR I = 1 TO IZ + 1
       X(I) = X(I - 1) + LC(I - 1)
    NEXT I
    LT = X(IZ + 1)
    LM = (C * B / (4 * E * IN)) ^ .25
    LK = 3.14159 / LM

END SUB

' ================================ CalcolaRisultati ============================
'
'   Calcola momento flettente, taglio, abbassamento, rotazione,
'   tensione nel terreno in pi sezioni, come sovrapposizione
'   degli schemi di trave di lunghezza infinita e seminfinita
'
'   Variabili di ingresso:
'      IZ        numero di pilastri
'      B         larghezza della sottofondazione
'      C         costante elastica di sottofondo
'      LM        parametro caratteristico lambda
'      LT        lunghezza totale della trave
'      LC()      luce delle campate;
'                   la luce dello sbalzo sinistro e` in LC(0)
'                   la luce dello sbalzo destro e` in LC(IZ)
'      X()       ascisse dei pilastri
'      Q         carico uniformemente distribuito
'      F()       forze concentrate trasmesse dai pilastri
'      M()       coppie trasmesse dai pilastri
'      X1,X2,X3,X4      forze correttive da applicare agli estremi
'
'   Variabili di uscita:
'      KX()      distanza dal primo estremo di una campata
'      W()       abbassamenti
'      FI()      rotazioni
'      T()       taglio
'      MF()      momento flettente
'      ST()      sigma del terreno
'
'   Variabili interne:
'      KZ        numero di intervalli in cui e` divisa la campata o lo sbalzo
'      K         indice che individua un punto generico in campata
'      I, J      indici che individuano il generico pilastro o campata
'      XK        ascissa del punto per il quale si calcolano i risultati
'      S         segno della distanza
'      WX        abbassamento
'      FX        rotazione
'      TX        taglio                                                          
'      MX        momento
'
'   Costanti predefinite:
'      DS        numero di intervalli in cui e` divisa lo sbalzo
'      DC        numero di intervalli in cui e` divisa la campata
'
' ------------------------------------------------------------------------------
SUB CalcolaRisultati (IZ, B, C, LM, LT, LC(), X(), Q, F(), M(), X1, X2, X3, X4, KX(), W(), FI(), T(), MF(), ST())

    FOR I = 0 TO IZ
       IF I = 0 OR I = IZ THEN
          KZ = DS
       ELSE
          KZ = DC
       END IF
       FOR K = 0 TO KZ
          XK = X(I) + K * LC(I) / KZ
          KX(I, K) = XK - X(I)
          W(I, K) = Q / (B * C)
          FI(I, K) = 0
          T(I, K) = 0
          MF(I, K) = 0
          FOR J = 1 TO IZ
             X = ABS(XK - X(J))
             IF J <= I THEN
                S = 1
             ELSE
                S = -1
             END IF
             CALL TraveInf(LM, B, C, X, S, F(J), M(J), WX, FX, MX, TX)
             W(I, K) = W(I, K) + WX
             FI(I, K) = FI(I, K) + FX
             T(I, K) = T(I, K) + TX
             MF(I, K) = MF(I, K) + MX
          NEXT J
          CALL TraveSeminf(LM, B, C, XK, 1, X1, X2, WX, FX, MX, TX)
          W(I, K) = W(I, K) + WX
          FI(I, K) = FI(I, K) + FX
          T(I, K) = T(I, K) + TX
          MF(I, K) = MF(I, K) + MX
          CALL TraveSeminf(LM, B, C, LT - XK, -1, X3, X4, WX, FX, MX, TX)
          W(I, K) = W(I, K) + WX
          FI(I, K) = FI(I, K) + FX
          T(I, K) = T(I, K) + TX
          MF(I, K) = MF(I, K) + MX
          ST(I, K) = W(I, K) * C
       NEXT K
    NEXT I

END SUB

' ================================ CoeffABCD ===================================
'
'   Calcola i coefficienti A,B,C,D in funzione di lambda x
'
'   Variabili di ingresso:
'      LM        parametro caratteristico lambda
'      X         ascissa o distanza
'
'   Variabili di uscita:
'      AL        coefficiente A
'      BL        coefficiente B
'      CL        coefficiente C
'      DL        coefficiente D
'
' ------------------------------------------------------------------------------
SUB CoeffABCD (LM, X, AL, BL, CL, DL)

    BL = EXP(-LM * X) * SIN(LM * X)
    DL = EXP(-LM * X) * COS(LM * X)
    AL = BL + DL
    CL = -BL + DL

END SUB

' ================================ DefinisceIO =================================
'
'   Definisce le unita` di ingresso e di uscita
'
'   Variabili di ingresso:
'      FI$       file di ingresso
'
'   Variabili di uscita:
'      FI$       file di ingresso
'      FO$       file di uscita
'
' ------------------------------------------------------------------------------
SUB DefinisceIO (FI$, FO$)

    CLS
    DIM UF(1)
    UF(1) = 13
   
    LOCATE 10, 11: PRINT "Nome del file che contiene i dati";
    UD$ = LCAR$(FI$, 12)
    CALL CampoT(0, 1, UF(), 10, 50, 12, "", UD$, UU)
    LOCATE 10, 50: PRINT UD$
    FI$ = RTRIM$(UD$)
   
    LOCATE 13, 11: PRINT "Unita` di uscita ?"
    LOCATE 14, 11: PRINT "CON=schermo, PRN=stampante, oppure nome di un file"
    UD$ = LCAR$(FO$, 12)
    CALL CampoT(0, 1, UF(), 13, 50, 12, "", UD$, UU)
    LOCATE 13, 50: PRINT UD$
    FO$ = RTRIM$(UD$)
  
END SUB

' ================================ Diagrammi ===================================
'
SUB Diagrammi (SCR, IZ, LT, KX(), X(), MF(), T(), W())
  
    IF SCR = 11 OR SCR = 12 THEN
       Riga = 30
    ELSE
       Riga = 25
    END IF
    ' --- disegna il diagramma del momento
    '     scala
    CALL ValEstremi(IZ, MF(), Mmin, Mmax)
    Mmax = MAX(Mmax, -Mmin)
    X1 = -.05 * LT
    X2 = 1.05 * LT
    Y1 = -1.2 * Mmax
    Y2 = 1.2 * Mmax
    WINDOW (X1, Y1)-(X2, Y2)
    '     sbalzo sinistro
    LINE (KX(0, 0), 0)-(KX(0, 0), -MF(0, 0))
    LINE -(KX(0, 1), -MF(0, 1))
    FOR J = 2 TO DS
       LINE -(KX(0, J), -MF(0, J))
    NEXT J
    X = KX(0, DS)
    '     campate
    FOR I = 1 TO IZ - 1
       IF I = 1 THEN X(I) = X
       FOR J = 0 TO DC
          LINE -(X(I) + KX(I, J), -MF(I, J))
       NEXT J
    NEXT I
    X1 = X(IZ - 1) + KX(IZ - 1, DC)
    '     sbalzo destro
    FOR J = 0 TO DS
       LINE -(X1 + KX(IZ, J), -MF(IZ, J))
    NEXT J
    LINE -(LT, 0)
    LINE (0, 0)-(LT, 0), , , &HF0F0
    LOCATE 1, 36: PRINT "MOMENTO"
    LOCATE Riga, 1: PRINT "premere un tasto per continuare";
    DO
       T$ = INKEY$
    LOOP UNTIL T$ <> ""
  
    ' --- disegna il diagramma del taglio
    '     scala
    CALL ValEstremi(IZ, T(), Tmin, Tmax)
    Tmax = MAX(Tmax, -Tmin)
    X1 = -.05 * LT
    X2 = 1.05 * LT
    Y1 = -1.2 * Tmax
    Y2 = 1.2 * Tmax
    CLS
    WINDOW (X1, Y1)-(X2, Y2)
    '     sbalzo sinistro
    LINE (KX(0, 0), 0)-(KX(0, 0), T(0, 0))
    LINE -(KX(0, 1), T(0, 1))
    FOR J = 2 TO DS
       LINE -(KX(0, J), T(0, J))
    NEXT J
    X = KX(0, DS)
    '     campate
    FOR I = 1 TO IZ - 1
       IF I = 1 THEN X(I) = X
       FOR J = 0 TO DC
          LINE -(X(I) + KX(I, J), T(I, J))
       NEXT J
    NEXT I
    X1 = X(IZ - 1) + KX(IZ - 1, DC)
    '     sbalzo destro
    FOR J = 0 TO DS
       LINE -(X1 + KX(IZ, J), T(IZ, J))
    NEXT J
    LINE -(LT, 0)
    LINE (0, 0)-(LT, 0), , , &HF0F0
    LOCATE 1, 37: PRINT "TAGLIO"
    LOCATE Riga, 1: PRINT "premere un tasto per continuare";
    DO
       T$ = INKEY$
    LOOP UNTIL T$ <> ""
   
    ' --- disegna il diagramma dell'abbassamento
    '     scala
    CALL ValEstremi(IZ, W(), Wmin, Wmax)
    Wmax = MAX(Wmax, -Wmin)
    X1 = -.05 * LT
    X2 = 1.05 * LT
    Y1 = -1.5 * Wmax
    Y2 = 1.5 * Wmax
    CLS
    WINDOW (X1, Y1)-(X2, Y2)
    '     sbalzo sinistro
    LINE (KX(0, 0), 0)-(KX(0, 0), -W(0, 0))
    LINE -(KX(0, 1), -W(0, 1))
    FOR J = 2 TO DS
       LINE -(KX(0, J), -W(0, J))
    NEXT J
    X = KX(0, DS)
    '     campate
    FOR I = 1 TO IZ - 1
       IF I = 1 THEN X(I) = X
       FOR J = 0 TO DC
          LINE -(X(I) + KX(I, J), -W(I, J))
       NEXT J
    NEXT I
    X1 = X(IZ - 1) + KX(IZ - 1, DC)
    '     sbalzo destro
    FOR J = 0 TO DS
       LINE -(X1 + KX(IZ, J), -W(IZ, J))
    NEXT J
    LINE -(LT, 0)
    LINE (0, 0)-(LT, 0), , , &HF0F0
    LOCATE 1, 34: PRINT "ABBASSAMENTO"
    LOCATE Riga, 1: PRINT "premere un tasto per continuare";
    DO
       T$ = INKEY$
    LOOP UNTIL T$ <> ""
    CLS

END SUB

' ================================ ForzeCorrettive =============================
'
'   Calcola le forze correttive da applicare agli schemi di trave
'   di lunghezza  seminfinita  per  annullare  i momenti  e tagli
'   che insorgerebbero  agli estremi  della  trave  di fondazione
'   se  si adottasse  lo schema  di trave  di lunghezza  infinita
'
'   Variabili di ingresso:
'      IZ        numero di pilastri
'      LT        lunghezza totale della trave
'      LM        parametro caratteristico lambda
'      B         larghezza della sottofondazione
'      C         costante elastica di sottofondo
'      F()       forze concentrate trasmesse dai pilastri
'      M()       coppie trasmesse dai pilastri
'      X()       ascisse dei pilastri
'
'   Variabili di uscita:
'      X1,X2,X3,X4      forze e coppie incognite da applicare allo
'                       schema di trave di lunghezza seminfinita
'
'   Variabili interne:
'      T1        taglio all'estremo sinistro
'      T2        taglio all'estremo destro
'      M1        momento all'estremo sinistro
'      M2        momento all'estremo destro
'      I         contatore
'      WX        abbassamento
'      FX        rotazione
'      MX        momento
'      TX        taglio
'      AL,BL,CL,DL           coefficienti A, B, C, D, calcolati per lambda LT
'      A1,B1,C1,A2,B2,C2,DE  coefficienti del sistema che fornisce X3, X4
'      DE        denominatore
'
' ------------------------------------------------------------------------------
SUB ForzeCorrettive (IZ, LT, LM, B, C, F(), M(), X(), X1, X2, X3, X4)

    ' determina momento e taglio agli estremi per trave di lunghezza infinita
    T1 = 0
    M1 = 0
    T2 = 0
    M2 = 0
    FOR I = 1 TO IZ
       CALL TraveInf(LM, B, C, X(I), -1, F(I), M(I), WX, FX, MX, TX)
       T1 = T1 + TX
       M1 = M1 + MX
       CALL TraveInf(LM, B, C, LT - X(I), 1, F(I), M(I), WX, FX, MX, TX)
       T2 = T2 + TX
       M2 = M2 + MX
    NEXT I

    ' determina le forze correttive
    CALL CoeffABCD(LM, LT, AL, BL, CL, DL)
    A1 = 1 - CL ^ 2 - 2 * BL ^ 2
    B1 = -4 * BL ^ 2 * LM
    C1 = -T2 + CL * T1 - 2 * BL * LM * M1
    A2 = -2 * BL ^ 2 / LM
    B2 = 1 - AL ^ 2 - 2 * BL ^ 2
    C2 = M2 - BL * T1 / LM - AL * M1
    DE = A1 * B2 - A2 * B1
    X3 = (C1 * B2 - C2 * B1) / DE
    X4 = (A1 * C2 - A2 * C1) / DE
    X1 = T1 + CL * X3 - 2 * BL * LM * X4
    X2 = -M1 + BL * X3 / LM + AL * X4

END SUB

' ================================ Inerzia =====================================
'
'   Calcola il momento d'inerzia di una sezione a T
'
' ------------------------------------------------------------------------------
SUB Inerzia

    CLS
    PRINT "Unita` di uscita ?"
    PRINT "CON=schermo, PRN=stampante"
    INPUT FO$
    OPEN "O", #1, FO$
    '
    DO
       CLS
       PRINT "CALCOLO DEL MOMENTO D'INERZIA DI UNA SEZIONE A T"
       PRINT
       PRINT "    INSERIRE LE SEGUENTI DIMENSIONI IN [m]"
       PRINT
       INPUT "    BASE ANIMA = "; B1
       INPUT "  BASE SEZIONE = "; B3
       INPUT "   ALTEZZA ALA = "; H2
       INPUT "ALTEZZA TOTALE = "; H1
       B2 = (B3 - B1) / 2
       A = B1 * H1 + 2 * B2 * H2
       S = B1 * H1 ^ 2 / 2 + B2 * H2 ^ 2
       X = S / A
       I = B1 * H1 ^ 3 / 3 + 2 * B2 * H2 ^ 3 / 3 - A * X ^ 2
       '
       PRINT #1,
       PRINT #1,
       PRINT #1, "  CALCOLO DEL MOMENTO D'INERZIA DI UNA SEZIONE A T"
       PRINT #1,
       PRINT #1, "        DATI DI INGRESSO         DATI DI USCITA"
       PRINT #1,
       PRINT #1, USING "        BASE ANIMA =##.## m        A = ##.##     m2"; B1; A
       PRINT #1, USING "      BASE SEZIONE =##.## m       Sx =###.##     m3"; B3; S
       PRINT #1, USING "       ALTEZZA ALA =##.## m       XG = ##.##     m "; H2; X
       PRINT #1, USING "    ALTEZZA TOTALE =##.## m        I =###.###### m4"; H1; I
       PRINT #1,
       '
       LOCATE 22, 1
       PRINT
       PRINT "VUOI RIPETERE IL CALCOLO (S/N)";
       r$ = UCASE$(INPUT$(1))
       DO WHILE r$ <> "S" AND r$ <> "N"
          CALL ErrBeep
          r$ = INPUT$(1)
       LOOP
    LOOP UNTIL r$ = "N"
    CLOSE #1
    CLS

END SUB

' ================================ InputDati ===================================
'
'   Consente di assegnare interattivamente i dati
'
'   Variabili di ingresso:
'      MIS       sistema di misura
'
'   Variabili di uscita:
'      FO$       file in cui sono stati conservati i dati
'
' ------------------------------------------------------------------------------
SUB InputDati (MIS, FO$)

    DIM Cod(3), Descr$(3)
    Cod(1) = -81: Descr$(1) = "PagSucc"
    Cod(2) = -73: Descr$(2) = "PagPrec"
    Cod(3) = -81: Descr$(3) = "  Fine "

    DIM NP(1 TO MI), LC(0 TO MI), F(1 TO MI), M(1 TO MI)

    Pag = 1
    DO
       SELECT CASE Pag
          CASE 1
             CALL Pagina1(Cod(), Descr$(), I$, FI$, FO$, UU)
             IF I$ = "SI" THEN
                OPEN "I", #1, FI$
                CALL LetturaDati(1, MIS, B, IN, EL, E, IZ, NP(), LC(), CS, C, Q, F(), M())
                CLOSE #1
             END IF
             IF UU = 1 THEN Pag = 2
          CASE 2
             CALL Pagina2(Cod(), Descr$(), MIS, B, IN, EL, CS, IZ, UU)
             IF UU = 1 THEN Pag = 1 ELSE Pag = 3
          CASE 3
             CALL Pagina3(Cod(), Descr$(), IZ, NP(), UU)
             IF UU = 1 THEN Pag = 2 ELSE Pag = 4
          CASE 4
             CALL Pagina4(Cod(), Descr$(), IZ, NP(), LC(), UU)
             IF UU = 1 THEN Pag = 3 ELSE Pag = 5
          CASE 5
             CALL Pagina5(Cod(), Descr$(), MIS, IZ, NP(), Q, F(), M(), UU)
             IF UU = 1 THEN Pag = 4 ELSE Pag = 6
       END SELECT
    LOOP UNTIL Pag = 6
  
    OPEN "O", #1, FO$
    CALL MemorizzazioneDati(1, B, IN, EL, IZ, NP(), LC(), CS, Q, F(), M())
    CLOSE #1

END SUB

' ================================ LetturaDati =================================
'
'   Legge i dati geometrici e di carico dal file associato al buffer F
'   N.B.  il file deve essere aperto e chiuso dal programma principale
'
'   Variabili di ingresso:
'      F         numero del buffer da cui leggere i dati
'      MIS       sistema di misura
'
'   Variabili di uscita:
'      B         larghezza della sottofondazione
'      IN        momento di inerzia della sezione
'      EL, E     modulo elastico del materiale
'      IZ        numero di pilastri
'      NP()      numerazione dei pilastri
'      LC()      luce delle campate;
'                   la luce dello sbalzo sinistro e` in LC(0)
'                   la luce dello sbalzo destro e` in LC(IZ)
'      CS, C     costante elastica di sottofondo
'      Q         carico uniformemente distribuito
'      F()       forze concentrate trasmesse dai pilastri
'      M()       coppie trasmesse dai pilastri
'
' ------------------------------------------------------------------------------
SUB LetturaDati (F, MIS, B, IN, EL, E, IZ, NP(), LC(), CS, C, Q, F(), M())

    INPUT #F, B, IN, EL, IZ
    FOR I = 1 TO IZ
       INPUT #F, NP(I)
    NEXT I
    FOR I = 0 TO IZ
       INPUT #F, LC(I)
    NEXT I
    INPUT #F, CS, Q
    FOR I = 1 TO IZ
       INPUT #F, F(I), M(I)
    NEXT I
    ' adegua modulo elastico e costante di sottofondo alle unita` di misura
    IF MIS = 1 THEN
       E = 10 * EL
       C = 1000 * CS
    ELSE
       E = 1000 * EL
       C = 1000 * CS
    END IF

END SUB

' ================================ MemorizzazioneDati ==========================
'
'   Scrive i dati geometrici e di carico nel file associato al buffer F
'   N.B.  il file deve essere aperto e chiuso dal programma principale
'
'   Variabili di ingresso:
'      F         numero del buffer in cui scrivere i dati
'      B         larghezza della sottofondazione
'      IN        momento di inerzia della sezione
'      EL        modulo elastico del materiale
'      IZ        numero di pilastri
'      NP()      numerazione dei pilastri
'      LC()      luce delle campate;
'                   la luce dello sbalzo sinistro e` in LC(0)
'                   la luce dello sbalzo destro e` in LC(IZ)
'      CS        costante elastica di sottofondo
'      Q         carico uniformemente distribuito
'      F()       forze concentrate trasmesse dai pilastri
'      M()       coppie trasmesse dai pilastri
'
' ------------------------------------------------------------------------------
SUB MemorizzazioneDati (F, B, IN, EL, IZ, NP(), LC(), CS, Q, F(), M())

    WRITE #F, B, IN, EL, IZ
    FOR I = 1 TO IZ
       WRITE #F, NP(I)
    NEXT I
    FOR I = 0 TO IZ
       WRITE #F, LC(I)
    NEXT I
    WRITE #F, CS, Q
    FOR I = 1 TO IZ
       WRITE #F, F(I), M(I)
    NEXT I

END SUB

' ================================ Menu ========================================
'
'  Menu principale per la scelta dell'operazione da effettuare
'
'  Variabili di ingresso:
'     SCR       modalita` grafica possibile
'
'  Variabili di uscita:
'     Op%       numero d'ordine dell'operazione da effettuare
'
' ------------------------------------------------------------------------------
SUB Menu (SCR, Op%)

    IF Op% = 0 AND SCR > 0 THEN
       SCREEN SCR
       CLS
       WINDOW (0, 0)-(100, 100)
       FOR I = 1 TO 20
          LINE (I, I)-(100 - I, 100 - I), 1, B
       NEXT I
       PAINT (50, 50), 1
       IF SCR = 11 OR SCR = 12 THEN
          Riga1 = 14
          Riga2 = 17
       ELSE
          Riga1 = 12
          Riga2 = 14
       END IF
       LOCATE Riga1, 23: PRINT " UNIVERSITA` DEGLI STUDI DI NAPOLI "
       LOCATE Riga2, 28: PRINT " FACOLTA` DI INGEGNERIA "
       CALL Aspetta(3)
    END IF
    SCREEN 0
    CLS
    PRINT "Ŀ";
    PRINT "             CATTEDRA DI COMPLEMENTI DI TECNICA DELLE COSTRUZIONI             ";
    PRINT "                                                                              ";
    PRINT "             gruppo di studio - anni accademici 1987/88 e 1989/90             ";
    PRINT "Ĵ";
    PRINT "                       TRAVE ELASTICA SU SUOLO ELASTICO                       ";
    PRINT "                                                                              ";
    PRINT "                              METODO  DI WINKLER                              ";
    PRINT "Ĵ";
    PRINT "                                                                              ";
    PRINT "                             ELENCO DEI PROGRAMMI                             ";
    PRINT "                                                                              ";
    PRINT "                        1 - CALCOLO INERZIA DELLA TRAVE                       ";
    PRINT "                                                                              ";
    PRINT "                        2 - IMMISSIONE INTERATTIVA DEI                        ";
    PRINT "                                 DATI DELLA TRAVE                             ";
    PRINT "                                                                              ";
    PRINT "                        3 - RISOLUZIONE DELLA TRAVE CON                       ";
    PRINT "                               INGRESSO DATI DA FILE                          ";
    PRINT "                                                                              ";
    PRINT "                        4 - TERMINE ELABORAZIONE                              ";
    PRINT "                                                                              ";
    PRINT "Ĵ";
    PRINT "              INSERIRE IL NUMERO ORDINE DEL PROGRAMMA DESIDERATO              ";
    LOCATE 25, 1
    PRINT "";
    '
    A$ = INPUT$(1)
    DO WHILE ASC(A$) < 49 OR ASC(A$) > 52
       CALL ErrBeep
       A$ = INPUT$(1)
    LOOP
    '
    Op% = VAL(A$)
    CLS

END SUB

' ================================ Pagina1 =====================================
'
'   Consente di assegnare interattivamente le informazioni generali
'
'   Variabili di ingresso:
'      Cod()     codici per i tasti
'      Descr$()  descrizione dei tasti
'
'   Variabili di ingresso/uscita:
'      I$        indicazione se modificare dati preesistenti (SI/NO)
'      FI$       nome del file di ingresso dati
'      FO$       nome del file di uscita dati
'
'   Variabili di uscita:
'      UU        numero d'ordine del tasto di uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina1 (Cod(), Descr$(), I$, FI$, FO$, UU)

    JZ = 3
    DIM UR(JZ), UC(JZ), UL(JZ), UD$(JZ)
    DIM Utst(7)
    '
    Utst(1) = 0
    Utst(2) = 0
    Utst(3) = 0
    Utst(4) = 0
    Utst(5) = 0
    Utst(6) = 1
    Utst(7) = 0
    '
    CLS
    LOCATE 3, 21:  PRINT "INDICAZIONI SUI FILES"
    LOCATE 5, 7:   PRINT "vuoi modificare valori gi memorizzati? (SI o NO)"
    LOCATE 8, 7:   PRINT "se SI   in quale file?"
    LOCATE 10, 7:  PRINT "in quale file vuoi memorizzare i nuovi valori?"
    LOCATE 20, 68: PRINT "pag.1"
    '
    UR(1) = 5:  UC(1) = 60: UL(1) = 2:  UD$(1) = I$
    UR(2) = 8:  UC(2) = 60: UL(2) = 10: UD$(2) = FI$
    UR(3) = 10: UC(3) = 60: UL(3) = 10: UD$(3) = FO$
    '
    CALL PaginaTf(Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)
    '
    IF SWC <> 0 THEN
       I$ = UCASE$(UD$(1))
       FI$ = UD$(2)
       FO$ = UD$(3)
    END IF

END SUB

' ================================ Pagina2 =====================================
'
'   Consente di assegnare interattivamente i dati geometrici generali
'
'   Variabili di ingresso:
'      Cod()     codici per i tasti
'      Descr$()  descrizione dei tasti
'      MIS       sistema di misura
'
'   Variabili di ingresso/uscita:
'      B         larghezza della sottofondazione
'      IN        momento di inerzia della sezione
'      EL        modulo elastico del materiale
'      CS        costante elastica di sottofondo
'      IZ        numero di pilastri
'
'   Variabili di uscita:
'      UU        numero d'ordine del tasto di uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina2 (Cod(), Descr$(), MIS, B, IN, EL, CS, IZ, UU)

    JZ = 5
    DIM UR(JZ), UC(JZ), UL(JZ), UD$(JZ)
    DIM Utst(7)
    '
    Utst(1) = 0
    Utst(2) = 0
    Utst(3) = 0
    Utst(4) = 0
    Utst(5) = 2
    Utst(6) = 1
    Utst(7) = 0
    '
    CLS
    LOCATE 3, 17:  PRINT "DATI GEOMETRICI ED ELASTICI"
    LOCATE 6, 7:   PRINT "BASE"
    LOCATE 6, 42:  PRINT "m"
    LOCATE 8, 7:   PRINT "INERZIA"
    LOCATE 8, 42:  PRINT "m^4"
    LOCATE 10, 7:  PRINT "MODULO ELASTICO"
    LOCATE 10, 42: IF MIS = 1 THEN PRINT "kg cm-" ELSE PRINT "N mm-"
    LOCATE 12, 7:  PRINT "COSTANTE DI SOTTOFONDO"
    LOCATE 12, 42: IF MIS = 1 THEN PRINT "kg cm-3" ELSE PRINT "N cm-3"
    LOCATE 14, 7:  PRINT "NUMERO DI PILASTRI"
    LOCATE 20, 68: PRINT "pag.2"
    '
    UR(1) = 6:  UC(1) = 33: UL(1) = 8: UD$(1) = RNUM$(B, UL(1))
    UR(2) = 8:  UC(2) = 33: UL(2) = 8: UD$(2) = RNUM$(IN, UL(2))
    UR(3) = 10: UC(3) = 33: UL(3) = 8: UD$(3) = RNUM$(EL, UL(3))
    UR(4) = 12: UC(4) = 33: UL(4) = 8: UD$(4) = RNUM$(CS, UL(4))
    UR(5) = 14: UC(5) = 33: UL(5) = 2: UD$(5) = RNUM$(IZ, UL(5))
    '
    CALL PaginaTf(Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)
    '
    IF SWC <> 0 THEN
       B = VAL(UD$(1))
       IN = VAL(UD$(2))
       EL = VAL(UD$(3))
       CS = VAL(UD$(4))
       IZ = VAL(UD$(5))
    END IF

END SUB

' ================================ Pagina3 =====================================
'
'   Consente di assegnare interattivamente la numerazione dei pilastri
'
'   Variabili di ingresso:
'      Cod()     codici per i tasti
'      Descr$()  descrizione dei tasti
'      IZ        numero di pilastri
'
'   Variabili di ingresso/uscita:
'      NP()      numerazione dei pilastri
'
'   Variabili di uscita:
'      UU        numero d'ordine del tasto di uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina3 (Cod(), Descr$(), IZ, NP(), UU)

    JZ = IZ
    DIM UR(JZ), UC(JZ), UL(JZ), UD$(JZ)
    DIM Utst(7)
    '
    Utst(1) = 0
    Utst(2) = 0
    Utst(3) = 0
    Utst(4) = 0
    Utst(5) = 2
    Utst(6) = 1
    Utst(7) = 0
    '
    CLS
    LOCATE 3, 17:  PRINT "NUMERAZIONE DEI PILASTRI"
    LOCATE 5, 7:   PRINT "numero pilastro"
    LOCATE 20, 68: PRINT "pag.3"
    '
    FOR I = 1 TO IZ
       UR(I) = 6 + I: UC(I) = 7: UL(I) = 3: UD$(I) = RNUM$(NP(I), UL(I))
    NEXT I
    '
    CALL PaginaTf(Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)
    '
    IF SWC <> 0 THEN
       FOR I = 1 TO IZ
          NP(I) = VAL(UD$(I))
       NEXT I
    END IF

END SUB

' ================================ Pagina4 =====================================
'
'   Consente di assegnare interattivamente la lunghezza di campate e sbalzi
'
'   Variabili di ingresso:
'      Cod()     codici per i tasti
'      Descr$()  descrizione dei tasti
'      IZ        numero di pilastri
'      NP()      numerazione dei pilastri
'
'   Variabili di ingresso/uscita:
'      LC()      luce delle campate;
'                   la luce dello sbalzo sinistro e` in LC(0)
'                   la luce dello sbalzo destro e` in LC(IZ)
'
'   Variabili di uscita:
'      UU        numero d'ordine del tasto di uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina4 (Cod(), Descr$(), IZ, NP(), LC(), UU)

    JZ = IZ + 1
    DIM UR(JZ), UC(JZ), UL(JZ), UD$(JZ)
    DIM Utst(7)
    '
    Utst(1) = 0
    Utst(2) = 0
    Utst(3) = 0
    Utst(4) = 0
    Utst(5) = 2
    Utst(6) = 1
    Utst(7) = 0
    '
    CLS
    LOCATE 3, 17:    PRINT "LUCI CAMPATE"
    LOCATE 5, 7:     PRINT "sbalzo sinistro        m"
    FOR I = 1 TO IZ - 1
       LOCATE 5 + I, 7: PRINT USING "campata ## -##         m"; NP(I); NP(I + 1)
    NEXT I
    LOCATE 5 + IZ, 7: PRINT "sbalzo destro          m"
    LOCATE 20, 68:   PRINT "pag.4"
    '
    FOR I = 1 TO IZ + 1
       UR(I) = 4 + I: UC(I) = 24: UL(I) = 5: UD$(I) = RNUM$(LC(I - 1), UL(I))
    NEXT I
    '
    CALL PaginaTf(Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)
    '
    IF SWC <> 0 THEN
       FOR I = 0 TO IZ
          LC(I) = VAL(UD$(I + 1))
       NEXT I
    END IF

END SUB

' ================================ Pagina5 =====================================
'
'   Consente di assegnare interattivamente i carichi
'
'   Variabili di ingresso:
'      Cod()     codici per i tasti
'      Descr$()  descrizione dei tasti
'      MIS       sistema di misura
'      IZ        numero di pilastri
'      NP()      numerazione dei pilastri
'
'   Variabili di ingresso/uscita:
'      Q         carico uniformemente distribuito
'      F()       forze concentrate trasmesse dai pilastri
'      M()       coppie trasmesse dai pilastri
'
'   Variabili di uscita:
'      UU        numero d'ordine del tasto di uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina5 (Cod(), Descr$(), MIS, IZ, NP(), Q, F(), M(), UU)

    DIM UF(3)
    UF(1) = -73
    UF(2) = 13
    UF(3) = -81
    CLS
    LOCATE 1, 11:  PRINT "Carico distribuito"
    LOCATE 1, 36: IF MIS = 1 THEN PRINT "t/m" ELSE PRINT "kN/m"
    UD$ = RNUM$(Q, 5)
    CALL CampoT(0, 3, UF(), 1, 30, 5, "", UD$, UU)
    Q = VAL(UD$)
    LOCATE 1, 30: PRINT RNUM$(Q, 5)
    IF UU = 1 THEN EXIT SUB

    RZ = IZ
    CZ = 2
    DIM UR(IZ), UC(2), UL(2), UD$(IZ, 2)
    DIM Utst(4)
    '
    Utst(1) = 0
    Utst(2) = 2
    Utst(3) = 1
    Utst(4) = 0
    '
    FOR I = 1 TO IZ
       LOCATE 6 + I, 13: PRINT NP(I)
    NEXT I
    '
    IF MIS = 1 THEN V$ = " (t" ELSE V$ = "(kN"
    LOCATE 3, 17: PRINT "FORZE E MOMENTI CONCENTRATI"
    LOCATE 5, 11: PRINT USING "pilastro           forza\ \)         coppia\ \m)"; V$; V$
    LOCATE 20, 68: PRINT "pag.5"
    '
    FOR I = 1 TO IZ
       UR(I) = 6 + I
    NEXT I
    FOR I = 1 TO IZ
       UC(1) = 31: UL(1) = 7: UD$(I, 1) = RNUM$(F(I), UL(1))
       UC(2) = 50: UL(2) = 7: UD$(I, 2) = RNUM$(M(I), UL(2))
    NEXT I
    '
    CALL PaginaTf2(1222, Cod(), Descr$(), Utst(), RZ, CZ, UR(), UC(), UL(), UD$(), UU, SWC)
    '
    FOR I = 1 TO IZ
       IF SWC <> 0 THEN
          F(I) = VAL(UD$(I, 1))
          M(I) = VAL(UD$(I, 2))
       END IF
    NEXT I

END SUB

' ================================ StampaDati ==================================
'
'   Stampa i dati geometrici e di carico nel file associato al buffer F
'   N.B.  il file deve essere aperto e chiuso  dal programma principale
'
'   Variabili di ingresso:
'      F         numero del buffer in cui scrivere i dati
'      MIS       sistema di misura
'      B         larghezza della sottofondazione
'      IN        momento di inerzia della sezione
'      EL        modulo elastico del materiale
'      IZ        numero di pilastri
'      NP()      numerazione dei pilastri
'      LC()      luce delle campate;
'                   la luce dello sbalzo sinistro e` in LC(0)
'                   la luce dello sbalzo destro e` in LC(IZ)
'      CS        costante elastica di sottofondo
'      LM        parametro caratteristico lambda
'      LK        lunghezza caratteristica
'      Q         carico uniformemente distribuito
'      F()       forze concentrate trasmesse dai pilastri
'      M()       coppie trasmesse dai pilastri
'
' ------------------------------------------------------------------------------
SUB StampaDati (F, MIS, B, IN, EL, IZ, NP(), LC(), CS, LM, LK, Q, F(), M())

    CLS
    PRINT #F, "   RISOLUZIONE DI UNO SCHEMA DI TRAVE ELASTICA SU SUOLO ELASTICO CON IL "
    PRINT #F, "                                METODO DI WINKLER"
    PRINT #F,
    PRINT #F,
    PRINT #F, "   TIPI DI CARICO AMMESSI: carico uniforme (uguale su tutte le campate)"
    PRINT #F, "                           forze verticali concentrate"
    PRINT #F, "                           coppie concentrate"
    PRINT #F,
    PRINT #F, "   CONVENZIONE DEI SEGNI PER I RISULTATI:"
    PRINT #F,
    PRINT #F, "      momento flettente: positivo se tende le fibre inferiori"
    PRINT #F, "      taglio:            positivo se diretto verso il basso, come azione"
    PRINT #F, "                            sulla faccia di normale uscente verso destra"
    PRINT #F, "      abbassamento:      positivo verso il basso"
    PRINT #F, "      rotazione:         positiva se oraria"
    PRINT #F,
    PRINT #F,
    PRINT #F, "   DATI GEOMETRICI, ELASTICI E CARATTERISTICHE DEL TERRENO:"
    PRINT #F,
    PRINT #F, USING "     Larghezza sottofondazione   #.## m"; B
    PRINT #F, USING "     Inerzia trave               #.###### m4"; IN
    IF MIS = 1 THEN V$ = "kg/cm2" ELSE V$ = "N/mm2"
    PRINT #F, USING "     Modulo elastico             ###### \    \"; EL; V$
    PRINT #F, USING "     Numero di pilastri         ##"; IZ
    PRINT #F, "                                    Luce"
    PRINT #F, USING "     Sbalzo sinistro             #.## m"; LC(0)
    FOR I = 1 TO IZ - 1
       PRINT #F, USING "     Campata ##-##              ##.## m"; NP(I); NP(I + 1); LC(I)
    NEXT I
    PRINT #F, USING "     Sbalzo destro               #.## m"; LC(IZ)
    IF MIS = 1 THEN V$ = "kg/cm3" ELSE V$ = "N/cm3"
    PRINT #F, USING "     Costante del terreno       ##.## " + V$; CS
    PRINT #F, USING "     Lambda                      #.## 1/m"; LM
    PRINT #F, USING "     Lunghezza caratteristica   ##.## m"; LK
    PRINT #F,
    PRINT #F,
    PRINT #F, "     DATI DI CARICO:"
    PRINT #F,
    IF MIS = 1 THEN V$ = "###.## t/m" ELSE V$ = "####.# kN/m"
    PRINT #F, USING "       Carico uniforme         " + V$; Q
    PRINT #F,
    PRINT #F, "        Pilastro                  Forza            Coppia"
    PRINT #F,
    FOR I = 1 TO IZ
       PRINT #F, USING "          ##                    "; NP(I);
       IF MIS = 1 THEN
          PRINT #F, USING "###.## t        #####.## tm"; F(I); M(I)
       ELSE
          PRINT #F, USING "####.# kN       ######.# kNm"; F(I); M(I)
       END IF
       PRINT #F,
    NEXT I

END SUB

' ================================ StampaRisultati =============================
'
'   Stampa i risultati nel file associato al buffer F
'   N.B.  il file deve essere aperto e chiuso dal programma principale
'
'   Variabili di ingresso:
'      F         numero del buffer in cui scrivere i dati
'      MIS       sistema di misura
'      IZ        numero di pilastri
'      NP()      numerazione dei pilastri
'      KX()
'      MF()
'      T()
'      ST()
'      W()
'      FI()
'
' ------------------------------------------------------------------------------
SUB StampaRisultati (F, MIS, IZ, NP(), KX(), MF(), T(), ST(), W(), FI())
 
    CLS
    PRINT #2,
    PRINT #2, "  SOLLECITAZIONI E DEFORMAZIONI DI TRAVE E TERRENO"
    PRINT #2,
    PRINT #2, "                    Momento   Taglio  Sigma ter. Abbassamento Rotazione"
    IF MIS = 1 THEN
       PRINT #2, "                      (tm)     (t)      (kg/cm2)      (cm)       (rad)"
    ELSE
       PRINT #2, "                     (kNm)     (kN)     (N/cm2)       (cm)       (rad)"
    END IF
    IF MIS = 1 THEN
       V$ = "####.##  ####.##    ####.##"
    ELSE
       V$ = "#####.#  #####.#    #####.#"
    END IF
    PRINT #2,
    PRINT #2, "    Sbalzo sinistro"
    FOR J = 0 TO DS
       PRINT #2, USING "      x=#.## m     " + V$ + "    ####.###     #.######"; KX(O, J); MF(0, J); T(0, J); ST(0, J) / 10; W(0, J) * 100; FI(0, J)
    NEXT J
    FOR I = 1 TO IZ - 1
       PRINT #2,
       PRINT #2, USING "    Campata ##-##"; NP(I); NP(I + 1)
       FOR J = 0 TO DC
          PRINT #2, USING "      x=#.## m     " + V$ + "    ####.###     #.######"; KX(I, J); MF(I, J); T(I, J); ST(I, J) / 10; W(I, J) * 100; FI(I, J)
       NEXT J
    NEXT I
    PRINT #2,
    PRINT #2, "    Sbalzo destro"
    FOR J = 0 TO DS
       PRINT #2, USING "      x=#.## m     " + V$ + "    ####.###     #.######"; KX(IZ, J); MF(IZ, J); T(IZ, J); ST(IZ, J) / 10; W(IZ, J) * 100; FI(IZ, J)
    NEXT J
    PRINT #2,
    PRINT #2,
    PRINT #2,
    
END SUB

' ================================ TraveInf ====================================
'
'   Calcola l'abbassamento, la rotazione, il momento e il taglio
'   nel punto di ascissa X della trave di lunghezza infinita
'   caricata da una forza P e da una coppia M
'
'   Variabili di ingresso:
'      LM        parametro caratteristico lambda
'      B         larghezza della sottofondazione
'      C         costante elastica di sottofondo
'      X         distanza del punto in valore assoluto
'      S         segno della distanza
'      P         forza concentrata
'      M         coppia applicata
'
'   Variabili di uscita:
'      WX        abbassamento
'      FX        rotazione
'      MX        momento
'      TX        taglio
'
'   Variabili interne:
'      AL, BL, CL, DL   coefficienti A, B, C, D, calcolati per lambda X
'
' ------------------------------------------------------------------------------
SUB TraveInf (LM, B, C, X, S, P, M, WX, FX, MX, TX)

    CALL CoeffABCD(LM, X, AL, BL, CL, DL)
    WX = P * LM * AL / (2 * B * C) + M * LM ^ 2 * BL * S / (B * C)
    FX = -P * LM ^ 2 * BL * S / (B * C) + M * LM ^ 3 * CL / (B * C)
    MX = P * CL / (4 * LM) + M * DL * S / 2
    TX = -P * DL * S / 2 - M * LM * AL / 2

END SUB

' ================================ TraveSeminf =================================
'
'   Calcola l'abbassamento, la rotazione, il momento e il taglio
'   nel punto di ascissa X della trave di lunghezza semi-infinita
'   caricata da una forza P e da una coppia M
'
'   Variabili di ingresso:
'      LM        parametro caratteristico lambda
'      B         larghezza della sottofondazione
'      C         costante elastica di sottofondo
'      X         distanza del punto in valore assoluto
'      S         segno della distanza
'      P         forza concentrata
'      M         coppia applicata
'
'   Variabili di uscita:
'      WX        abbassamento
'      FX        rotazione
'      MX        momento
'      TX        taglio
'
'   Variabili interne:
'      AL, BL, CL, DL   coefficienti A, B, C, D, calcolati per lambda X
'
' ------------------------------------------------------------------------------
SUB TraveSeminf (LM, B, C, X, S, P, M, WX, FX, MX, TX)

    CALL CoeffABCD(LM, X, AL, BL, CL, DL)
    WX = 2 * P * LM * DL / (B * C) - 2 * M * LM ^ 2 * CL * S / (B * C)
    FX = -2 * P * LM ^ 2 * AL * S / (B * C) + 4 * M * LM ^ 3 * DL / (B * C)
    MX = -P * BL / LM + M * AL * S
    TX = -P * CL * S - 2 * M * LM * BL

END SUB

' ================================ ValEstremi ==================================
'
SUB ValEstremi (IZ, A(), Amin, Amax)

    Amin = 0
    Amax = 0
    FOR I = 0 TO IZ
       FOR J = 0 TO DC
          IF A(I, J) < Amin THEN Amin = A(I, J)
          IF A(I, J) > Amax THEN Amax = A(I, J)
       NEXT J
    NEXT I

END SUB

' ================================ Winkler =====================================
'
'   Effettua la risoluzione dello schema di trave su suolo alla Winkler
'
'   Variabili di ingresso:
'      MIS       sistema di misura
'      SCR       modalita` grafica possibile
'      FI$       file in cui sono stati conservati i dati nella fase interattiva
'
' ------------------------------------------------------------------------------
SUB Winkler (MIS, SCR, FI$)

    DIM NP(1 TO MI), LC(0 TO MI), F(1 TO MI), M(1 TO MI), X(0 TO MI + 1)
    DIM KX(0 TO MI, 0 TO DC), W(0 TO MI, 0 TO DC), FI(0 TO MI, 0 TO DC)
    DIM T(0 TO MI, 0 TO DC), MF(0 TO MI, 0 TO DC), ST(0 TO MI, 0 TO DC)

    CALL DefinisceIO(FI$, FO$)
    OPEN "I", #1, FI$
    OPEN "O", #2, FO$
    CALL LetturaDati(1, MIS, B, IN, EL, E, IZ, NP(), LC(), CS, C, Q, F(), M())
    CALL Ascisse(IZ, B, C, E, IN, LC(), X(), LT, LM, LK)
    CALL ForzeCorrettive(IZ, LT, LM, B, C, F(), M(), X(), X1, X2, X3, X4)
    CALL CalcolaRisultati(IZ, B, C, LM, LT, LC(), X(), Q, F(), M(), X1, X2, X3, X4, KX(), W(), FI(), T(), MF(), ST())
    CALL StampaDati(2, MIS, B, IN, EL, IZ, NP(), LC(), CS, LM, LK, Q, F(), M())
    CALL StampaRisultati(2, MIS, IZ, NP(), KX(), MF(), T(), ST(), W(), FI())
    IF SCR = 0 THEN
       PRINT
       PRINT "Impossibile visualizzare i diagrammi"
    ELSE
       SCREEN SCR
       CALL Diagrammi(SCR, IZ, LT, KX(), X(), MF(), T(), W())
    END IF
    CLOSE #1
    CLOSE #2

END SUB

